# Hooks > Incomings

When data arrive to a scheduled webhook, Make places the data in the webhook processing queue. Webhooks process data in the same order as they arrive. The following endpoints allow you to inspect and update the webhook processing queue.

## Get webhook queue

> Retrieves a list of webhook queue items waiting for processing with the specified webhook. The request response contains:\
> \
> \- the incoming payload hash\
> &#x20;\- incoming data scope\
> &#x20;\- the size of the data in bytes\
> &#x20;\- timestamp of the moment when the data were placed in the processing queue

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"Hooks > Incomings","description":"When data arrive to a scheduled webhook, Make places the data in the webhook processing queue. Webhooks process data in the same order as they arrive. The following endpoints allow you to inspect and update the webhook processing queue."}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["hooks:read"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/hooks/{hookId}/incomings":{"get":{"tags":["Hooks > Incomings"],"summary":"Get webhook queue","description":"Retrieves a list of webhook queue items waiting for processing with the specified webhook. The request response contains:\n\n- the incoming payload hash\n - incoming data scope\n - the size of the data in bytes\n - timestamp of the moment when the data were placed in the processing queue","parameters":[{"name":"hookId","in":"path","schema":{"type":"integer"},"required":true,"description":"The ID of the webhook. Use the `GET /hooks` API call to get the ID values of your webhooks."},{"name":"pg[sortBy]","in":"query","schema":{"type":"string"},"description":"The value that will be used to sort returned entities by."},{"name":"pg[offset]","in":"query","schema":{"type":"integer"},"description":"The value of entities you want to skip before getting entities you need."},{"name":"pg[sortDir]","in":"query","schema":{"type":"string","enum":["asc","desc"]},"description":"The sorting order. It accepts the ascending and descending direction specifiers."},{"name":"pg[limit]","in":"query","schema":{"type":"integer"},"description":"Sets the maximum number of results per page in the API call response. For example, `pg[limit]=100`. The default number varies with different API endpoints."}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"incomings":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string"},"scope":{"type":"string"},"size":{"type":"integer"},"created":{"type":"string","format":"date-time"},"data":{"type":"object"}}}},"pg":{"type":"object","properties":{"last":{"type":"string"},"showLast":{"type":"boolean"},"sortBy":{"type":"string"},"sortDir":{"type":"string"},"limit":{"type":"integer"},"offset":{"type":"integer"}}}}}}}}}}}}}
```

## Delete items from webhook queue

> Deletes items from the processing queue of the specified webhook. Specify the payload ID values that you want to delete in the request body in the \`ids\` array.\
> \
> You can set the \`"all": true\` pair to delete all items from the webhook processing queue. If you use the \`"all": true\` parameter, you have to specify the \`confirmed=true\` query parameter to confirm the deletion. Otherwise the API call returns the error IM004 (406).\
> \
> Add the \`exceptIds\` array to the request body to specify items you don't want to delete.\
> \
> The API call response will contain an error message if some of the specified queue items cannot be deleted. The rest of the specified items will be deleted. Deleting a webhook queue item is not allowed when the item is already being processed by the webhook.

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"Hooks > Incomings","description":"When data arrive to a scheduled webhook, Make places the data in the webhook processing queue. Webhooks process data in the same order as they arrive. The following endpoints allow you to inspect and update the webhook processing queue."}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["hooks:write"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/hooks/{hookId}/incomings":{"delete":{"tags":["Hooks > Incomings"],"summary":"Delete items from webhook queue","description":"Deletes items from the processing queue of the specified webhook. Specify the payload ID values that you want to delete in the request body in the `ids` array.\n\nYou can set the `\"all\": true` pair to delete all items from the webhook processing queue. If you use the `\"all\": true` parameter, you have to specify the `confirmed=true` query parameter to confirm the deletion. Otherwise the API call returns the error IM004 (406).\n\nAdd the `exceptIds` array to the request body to specify items you don't want to delete.\n\nThe API call response will contain an error message if some of the specified queue items cannot be deleted. The rest of the specified items will be deleted. Deleting a webhook queue item is not allowed when the item is already being processed by the webhook.","parameters":[{"name":"hookId","in":"path","schema":{"type":"integer"},"required":true,"description":"The ID of the webhook. Use the `GET /hooks` API call to get the ID values of your webhooks."},{"name":"confirmed","in":"query","schema":{"type":"boolean"},"description":"Set to `true` to confirm deleting the webhook queue items. Otherwise the API call fails with the error IM004 (406)."}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"ids":{"type":"array","items":{"type":"string"},"description":"The ID values of the webhook processing queue items that you want to delete. Use the API call `GET /hooks/{hookId}/incomings` to get the ID values of the webhook processing queue items."},"exceptIds":{"type":"array","items":{"type":"string"},"description":"If you are deleting all of the incomplete executions with the `all:true` parameter, you can specify the ID values of the webhook queue items that you want to keep. Use the API call `GET /hooks/{hookId}/incomings` to get the ID values of the webhook queue items."},"all":{"type":"boolean","description":"Set to `true` to delete all items in the webhook processing queue."}}}}}},"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"incomings":{"type":"array","items":{"type":"string"}},"error":{"type":"object","properties":{"name":{"type":"string"},"message":{"type":"string"}}}}}}}}}}}}}
```

## Get webhook queue item detail

> Retrieves detail information about the specified webhook queue item. You can get the webhook queue item ID value with the API call \`GET /hooks/{hookId}/incomings\`.

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"Hooks > Incomings","description":"When data arrive to a scheduled webhook, Make places the data in the webhook processing queue. Webhooks process data in the same order as they arrive. The following endpoints allow you to inspect and update the webhook processing queue."}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["hooks:read"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/hooks/{hookId}/incomings/{incomingId}":{"get":{"tags":["Hooks > Incomings"],"summary":"Get webhook queue item detail","description":"Retrieves detail information about the specified webhook queue item. You can get the webhook queue item ID value with the API call `GET /hooks/{hookId}/incomings`.","parameters":[{"name":"hookId","in":"path","schema":{"type":"integer"},"required":true,"description":"The ID of the webhook. Use the `GET /hooks` API call to get the ID values of your webhooks."},{"name":"incomingId","in":"path","schema":{"type":"string"},"required":true,"description":"The ID value of the webhook queue item. Get the list of webhook queue items with the API call `GET /hooks/{hookId}/incomings`."}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"incoming":{"type":"object","properties":{"id":{"type":"string"},"scope":{"type":"string"},"size":{"type":"integer"},"created":{"type":"string","format":"date-time"},"data":{"type":"object"}}}}}}}}}}}}}
```

## Get webhook queue stats

> Gets webhook processing queue stats. The response contains the number of items in the webhook queue and the webhook queue limit.

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"Hooks > Incomings","description":"When data arrive to a scheduled webhook, Make places the data in the webhook processing queue. Webhooks process data in the same order as they arrive. The following endpoints allow you to inspect and update the webhook processing queue."}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["hooks:read"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/hooks/{hookId}/incomings/stats":{"get":{"tags":["Hooks > Incomings"],"summary":"Get webhook queue stats","description":"Gets webhook processing queue stats. The response contains the number of items in the webhook queue and the webhook queue limit.","parameters":[{"name":"hookId","in":"path","schema":{"type":"integer"},"required":true,"description":"The ID of the webhook. Use the `GET /hooks` API call to get the ID values of your webhooks."}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"incomingStat":{"type":"object","properties":{"queue":{"type":"integer"},"limit":{"type":"integer"},"enabled":{"type":"boolean"}}}}}}}}}}}}}
```
